chiark / gitweb /
fix todos, all NOTES now in code
[dgit.git] / dgit
diff --git a/dgit b/dgit
index 82754b66995728a55b6f0c91c77153c938a6db17..db65aaac454a447c17365712eaa44089fccd652a 100755 (executable)
--- a/dgit
+++ b/dgit
@@ -26,24 +26,38 @@ use Dpkg::Control::Hash;
 use File::Path;
 use POSIX;
 
-open DEBUG, ">&STDERR" or die $!;
-
 our $mirror = 'http://mirror.relativity.greenend.org.uk/mirror/debian-ftp/';
 our $suite = 'sid';
 our $package;
 
+our $sign = 1;
+our $dryrun = 0;
+our $changesfile;
+
 our $aliothname = 'iwj@git.debian.org';
-our $aliothpath = '/git/dgit-test';
+our $aliothpath = '/git/dgit-repos';
 our $alioth_git = "git+ssh://$aliothname/$aliothpath";
 our $alioth_sshtestbodge = [$aliothname,$aliothpath];
 
-our (@dget_opts) = qw(-u);
-our (@git_tag_opts);
+our %format_ok = map { $_=>1 } ("1.0","3.0 (native)","3.0 (quilt)");
+
+our (@git) = qw(git);
+our (@dget) = qw(dget);
+our (@dput) = qw(dput);
+our (@debsign) = qw(debsign);
+our $keyid;
+
+open DEBUG, ">/dev/null" or die $!;
+
+our %opts_opt_map = ('dget' => \@dget,
+                    'dput' => \@dput,
+                    'debsign' => \@debsign);
 
 our $remotename = 'dgit';
-our $ourdscfield = 'Vcs-git-master';
+our $ourdscfield = 'Vcs-Git-Master';
+our $branchprefix = 'dgit';
 
-sub uploadbranch () { return "dgit/$suite"; }
+sub uploadbranch () { return "$branchprefix/$suite"; }
 sub lref ($) { return "refs/heads/$_[0]"; }
 sub rref ($) { return "refs/remotes/$remotename/$_[0]"; }
 sub debiantag ($) { return "debian/$_[0]"; }
@@ -55,7 +69,7 @@ sub url_get {
        $ua = LWP::UserAgent->new();
        $ua->env_proxy;
     }
-    print DEBUG "fetching @_...\n";
+    print "fetching @_...\n";
     my $r = $ua->get(@_) or die $!;
     die "$_[0]: ".$r->status_line."; failed.\n" unless $r->is_success;
     return $r->decoded_content();
@@ -63,22 +77,58 @@ sub url_get {
 
 our ($dscdata,$dscurl,$dsc);
 
+sub printcmd {
+    my $fh = shift @_;
+    my $intro = shift @_;
+    print $fh $intro or die $!;
+    local $_;
+    foreach my $a (@_) {
+       $_ = $a;
+       if (s{['\\]}{\\$&}g || m{\s} || m{[^-_./0-9a-z]}i) {
+           print $fh " '$_'" or die $!;
+       } else {
+           print $fh " $_" or die $!;
+       }
+    }
+    print $fh "\n" or die $!;
+}
+
 sub runcmd {
+    printcmd(\*DEBUG,"+",@_);
     $!=0; $?=0;
     die "@_ $! $?" if system @_;
 }
 
-sub cmdoutput {
+sub cmdoutput_errok {
+    printcmd(\*DEBUG,"|",@_);
     open P, "-|", @_ or die $!;
     my $d;
     $!=0; $?=0;
     { local $/ = undef; $d = <P>; }
     die if P->error;
-    close P or die "@_ $? $!";
+    close P or return undef;
     chomp $d;
     return $d;
 }
 
+sub cmdoutput {
+    my $d = cmdoutput_errok @_;
+    defined $d or die "@_ $? $!";
+    return $d;
+}
+
+sub dryrun_report {
+    printcmd(\*STDOUT,"#",@_);
+}
+
+sub runcmd_ordryrun {
+    if (!$dryrun) {
+       runcmd @_;
+    } else {
+       dryrun_report @_;
+    }
+}
+
 sub parsecontrol {
     my $c = Dpkg::Control::Hash->new();
     $c->load(@_) or return undef;
@@ -87,48 +137,63 @@ sub parsecontrol {
 
 sub parsechangelog {
     my $c = Dpkg::Control::Hash->new();
-    my $p = new IO::File '-|', qw(dpkg-parsechangelog) or die $!;
+    my $p = new IO::Handle;
+    open $p, '-|', qw(dpkg-parsechangelog) or die $!;
     $c->parse($p);
     $?=0; $!=0; close $p or die "$! $?";
     return $c;
 }
 
-sub get_archive_dsc () {
-    my $rmad = cmdoutput qw(rmadison -asource),"-s$suite",$package;
+our $rmad;
+
+sub askmadison () {
+    $rmad ||= cmdoutput qw(rmadison -asource),"-s$suite",$package;
     $rmad =~ m/^ \s*( [^ \t|]+ )\s* \|
                  \s*( [^ \t|]+ )\s* \|
                  \s*( [^ \t|]+ )\s* \|
                  \s*( [^ \t|]+ )\s* /x or die "$rmad $?";
     $1 eq $package or die "$rmad $package ?";
     my $vsn = $2;
-    $3 eq $suite or die "$rmad $suite ?";
+    if ($suite ne $3) {
+       # madison canonicalises for us
+       print "canonical suite name for $suite is $3\n";
+       $suite = $3;
+    }
     $4 eq 'source' or die "$rmad ?";
-    # fixme it does not show us the component ?
+    return $vsn;
+}
+
+sub canonicalise_suite () {
+    askmadison();
+}
+
+sub get_archive_dsc () {
+    my $vsn = askmadison();
+    # fixme madison does not show us the component
     my $prefix = substr($package, 0, $package =~ m/^l/ ? 4 : 1);
     $dscurl = "$mirror/pool/main/$prefix/$package/${package}_$vsn.dsc";
-#print DEBUG Dumper($pdodata, $&, $dscurl);
     $dscdata = url_get($dscurl);
     my $dscfh = new IO::File \$dscdata, '<' or die $!;
-#print DEBUG Dumper($dscdata, $dscfh);
+    print DEBUG Dumper($dscdata);
     $dsc = Dpkg::Control::Hash->new(allow_pgp=>1);
     $dsc->parse($dscfh, 'dsc') or die "parsing of $dscurl failed\n";
-#print DEBUG Dumper($dsc);
+    print DEBUG Dumper($dsc);
     my $fmt = $dsc->{Format};
-    die "unsupported format $fmt, sorry\n" unless $fmt eq '1.0';
+    die "unsupported format $fmt, sorry\n" unless $format_ok{$fmt};
 }
 
 sub check_for_git () {
     # returns 0 or 1
     my $cmd= 
        "ssh $alioth_sshtestbodge->[0] '".
-       " set -e; cd /git/dgit-test;".
+       " set -e; cd $alioth_sshtestbodge->[1];".
        " if test -d $package.git; then echo 1; else echo 0; fi".
        "'";
-    #print DEBUG "$cmd\n";
+    print DEBUG "$cmd\n";
     open P, "$cmd |" or die $!;
     $!=0; $?=0;
     my $r = <P>; close P;
-#print STDERR ">$r<\n";
+    print DEBUG ">$r<\n";
     die "$r $! $?" unless $r =~ m/^[01]$/;
     return $r+0;
 }
@@ -155,29 +220,38 @@ sub mktree_in_ud_from_only_subdir () {
     runcmd qw(git init -q);
     rmtree('.git/objects');
     symlink '../../../../objects','.git/objects' or die $!;
-    runcmd qw(git add -Af);
-    my $tree = cmdoutput qw(git write-tree);
+    runcmd @git, qw(add -Af);
+    my $tree = cmdoutput @git, qw(write-tree);
     chomp $tree; $tree =~ m/^\w+$/ or die "$tree ?";
     return ($tree,$dir);
 }
 
+sub dsc_files () {
+    map {
+       m/^\w+ \d+ (\S+)$/ or die "$_ ?";
+       $1;
+    } grep m/\S/, split /\n/, ($dsc->{'Checksums-Sha256'} || $dsc->{Files});
+}
+
+sub is_orig_file ($) {
+    local ($_) = @_;
+    m/\.orig(?:-\w+)?\.tar\.\w+$/;
+}
+
 sub generate_commit_from_dsc () {
     prep_ud();
     chdir $ud or die $!;
     my @files;
-    foreach (split /\n/, ($dsc->{'Checksums-Sha256'} || $dsc->{Files})) {
-       next unless m/\S/;
-       m/^\w+ \d+ (\S+)$/ or die "$_ ?";
-       my $f = $1;
+    foreach my $f (dsc_files()) {
        die if $f =~ m#/|^\.|\.dsc$|\.tmp$#;
        push @files, $f;
        link "../../../$f", $f
            or $!==&ENOENT
            or die "$f $!";
     }
-    runcmd qw(dget), @dget_opts, qw(--), $dscurl;
-    foreach my $f (grep { m/\.tar\.gz$/ } @files) {
-       link $f, "../../../$f"
+    runcmd @dget, qw(--), $dscurl;
+    foreach my $f (grep { is_orig_file($_) } @files) {
+       link $f, "../../../../$f"
            or $!==&EEXIST
            or die "$f $!";
     }
@@ -191,7 +265,7 @@ sub generate_commit_from_dsc () {
     $authline =~ m/^[^<>]+ \<\S+\> \d+ [-+]\d+$/ or die $authline;
     open C, ">../commit.tmp" or die $!;
     print C "tree $tree\n" or die $!;
-    print C "parent $upload_hash\n" or die $! if defined $upload_hash;
+    print C "parent $upload_hash\n" or die $! if $upload_hash;
     print C <<END or die $!;
 author $authline
 committer $authline
@@ -202,16 +276,16 @@ $clogp->{Changes}
 END
     close C or die $!;
     print "synthesised git commit from .dsc $clogp->{Version}\n";
-    my $commithash = cmdoutput qw(git hash-object -w -t commit ../commit.tmp);
+    my $commithash = cmdoutput @git, qw(hash-object -w -t commit ../commit.tmp);
     chdir '../../../..' or die $!;
-    cmdoutput qw(git update-ref -m),"dgit synthesise $clogp->{Version}",
+    cmdoutput @git, qw(update-ref -m),"dgit synthesise $clogp->{Version}",
               'DGIT_ARCHIVE', $commithash;
-    cmdoutput qw(git log -n2), $commithash;
+    cmdoutput @git, qw(log -n2), $commithash;
     # ... gives git a chance to complain if our commit is malformed
     my $outputhash = $commithash;
-    if (defined $upload_hash) {
+    if ($upload_hash) {
        chdir "$ud/$dir" or die $!;
-       runcmd qw(git reset --hard), $upload_hash;
+       runcmd @git, qw(reset --hard), $upload_hash;
        runcmd qw(sh -ec), 'dpkg-parsechangelog >>../changelogold.tmp';
        my $oldclogp = Dpkg::Control::Hash->new();
        $oldclogp->parse('../changelogold.tmp','previous changelog') or die;
@@ -236,13 +310,31 @@ END
     return $outputhash;
 }
 
+sub ensure_we_have_orig () {
+    foreach my $f (dsc_files()) {
+       next unless is_orig_file($f);
+       if (stat "../$f") {
+           die "$f ?" unless -f _;
+       } else {
+           die "$f $!" unless $!==&ENOENT;
+       }
+       my $origurl = $dscurl;
+       $origurl =~ s{/[^/]+$}{};
+       $origurl .= "/$f";
+       die "$f ?" unless $f =~ m/^${package}_/;
+       die "$f ?" if $f =~ m#/#;
+       runcmd_ordryrun qw(sh -ec),'cd ..; exec "$@"','x',
+           @dget,'--',$origurl;
+    }
+}
+
 sub rev_parse ($) {
-    return cmdoutput qw(git rev-parse --), "$_[0]~0";
+    return cmdoutput @git, qw(rev-parse), "$_[0]~0";
 }
 
 sub is_fast_fwd ($$) {
     my ($ancestor,$child) = @_;
-    my $mb = cmdoutput qw(git merge-base), $dsc_hash, $upload_hash;
+    my $mb = cmdoutput @git, qw(merge-base), $dsc_hash, $upload_hash;
     return rev_parse($mb) eq rev_parse($ancestor);
 }
 
@@ -250,29 +342,38 @@ sub fetch_from_archive () {
     # ensures that rref(uploadbranch()) is what is actually in the archive,
     #  one way or another
     my $upload_ref = rref(uploadbranch());
-    $!=0; $upload_hash = `git show-ref --heads $upload_ref`;
+    $!=0; $upload_hash =
+       cmdoutput_errok @git, qw(show-ref --heads), $upload_ref;
     die $! if $!;
     die $? unless ($?==0 && chomp $upload_hash) 
-       or ($?==128 && !length $upload_hash);
+       or ($?==256 && !length $upload_hash);
+    $upload_hash ||= '';
     my $hash;
     if (defined $dsc_hash) {
        die "missing git history even though dsc has hash"
-           unless length $upload_hash;
+           unless $upload_hash;
        $hash = $dsc_hash;
+       ensure_we_have_orig();
     } else {
        $hash = generate_commit_from_dsc();
     }
-    if (length $upload_hash) {
+    if ($upload_hash) {
        die "not fast forward on last upload branch!".
            " (archive's version left in DGIT_ARCHIVE)"
            unless is_fast_fwd($dsc_hash, $upload_hash);
     }
     if ($upload_hash ne $hash) {
-       cmdoutput qw(git update-ref -m), 'dgit fetch', $upload_ref, $hash;
+       my @upd_cmd = (@git, qw(update-ref -m), 'dgit fetch', $upload_ref, $hash);
+       if (!$dryrun) {
+           cmdoutput @upd_cmd;
+       } else {
+           dryrun_report @upd_cmd;
+       }
     }
 }
 
 sub clone () {
+    die "dry run makes no sense with clone" if $dryrun;
     get_archive_dsc();
     $dsc_hash = $dsc->{$ourdscfield};
     if (defined $dsc_hash) {
@@ -283,33 +384,35 @@ sub clone () {
        print "last upload to archive has NO git hash\n";
     }
     my $dstdir = "$package";
+    my $branch = uploadbranch();
     if (check_for_git()) {
        print "cloning existing git history\n";
-       runcmd qw(git clone --origin),$remotename, qw(-b), $suite, '--',
-           $alioth_git, $dstdir;
+       runcmd @git, qw(clone --origin),$remotename, qw(-b), $branch, '--',
+           "$alioth_git/$package.git", $dstdir;
        chdir "$dstdir" or die "$dstdir $!";
        fetch_from_archive();
-       runcmd qw(git reset --hard), rref(uploadbranch());
+       runcmd @git, qw(reset --hard), rref(uploadbranch());
     } else {
        print "starting new git history\n";
        mkdir $dstdir or die "$dstdir $!";
        chdir "$dstdir" or die "$dstdir $!";
-       runcmd qw(git init -q);
+       runcmd @git, qw(init -q);
        open H, "> .git/HEAD" or die $!;
        print H "ref: ".lref(uploadbranch())."\n" or die $!;
        close H or die $!;
-       runcmd qw(git remote add), $remotename, $alioth_git;
-       runcmd "git config branch.$suite.remote $remotename";
-       runcmd "git config branch.$suite.merge ".lref(uploadbranch());
+       runcmd @git, qw(remote add), $remotename, "$alioth_git/$package.git";
+       runcmd "git config branch.$branch.remote $remotename";
+       runcmd "git config branch.$branch.merge ".lref(uploadbranch());
        my $newhash = generate_commit_from_dsc();
-       runcmd qw(git reset --hard), $newhash;
+       runcmd @git, qw(reset --hard), $newhash;
     }
     print "ready for work in $dstdir\n";
 }
 
 sub fetch () {
+    get_archive_dsc();
     if (check_for_git()) {
-       runcmd qw(git fetch -p),$remotename,
+       runcmd_ordryrun @git, qw(fetch -p),$remotename,
            '+refs/heads/*:refs/remotes/origin/*';
     }
     fetch_from_archive();
@@ -317,43 +420,65 @@ sub fetch () {
 
 sub pull () {
     fetch();
-    runcmd qw(git merge -m),"Merge from $suite [dgit]",lref(uploadbranch());
+    runcmd_ordryrun @git, qw(merge -m),"Merge from $suite [dgit]",
+        lref(uploadbranch());
 }
 
 sub dopush () {
-    runcmd qw(git diff --quiet HEAD);
+    runcmd @git, qw(diff --quiet HEAD);
     my $clogp = parsechangelog();
     $package = $clogp->{Source};
     my $dscfn = "${package}_$clogp->{Version}.dsc";
-    stat $dscfn or die "$dscfn $!";
+    stat "../$dscfn" or die "$dscfn $!";
     $dsc = parsecontrol("../$dscfn");
     prep_ud();
     chdir $ud or die $!;
     print "checking that $dscfn corresponds to HEAD\n";
     runcmd qw(dpkg-source -x --), "../../../../$dscfn";
-    my $tree = mktree_in_ud_from_only_subdir();
+    my ($tree,$dir) = mktree_in_ud_from_only_subdir();
     chdir '../../../..' or die $!;
-    runcmd qw(git diff --exit-code), $tree;
+    runcmd @git, qw(diff --exit-code), $tree;
 #fetch from alioth
 #do fast forward check and maybe fake merge
 #    if (!is_fast_fwd(mainbranch
-#    runcmd qw(git fetch -p ), $alioth_git,
+#    runcmd @git, qw(fetch -p ), "$alioth_git/$package.git",
 #        map { lref($_).":".rref($_) }
 #        (uploadbranch());
     $dsc->{$ourdscfield} = rev_parse('HEAD');
     $dsc->save("../$dscfn.tmp") or die $!;
-    rename "../$dscfn.tmp","../$dscfn" or die "$dscfn $!";
-    if ($sign) {
-       runcmd qw(git tag -s),@git_tag_opts,qw(-m),
-           "Release $dsc->{Version} for $suite [dgit]";
-       unlink "../$dscfn.asc" or $!==&ENOENT or die "$dscfn.asc $!";
-       runcmd qw(gpg --clearsign),@gpg_opts,"../$dscfn";
-       rename "../$dscfn.asc","../$dscfn" or die "$dscfn $!";
+    if (!$dryrun) {
+       rename "../$dscfn.tmp","../$dscfn" or die "$dscfn $!";
+    } else {
+       print "[new .dsc left in $dscfn.tmp]\n";
+    }
+    if (!$changesfile) {
+       my $pat = "../${package}_$clogp->{Version}_*.changes";
+       my @cs = glob $pat;
+        die "$pat ?" unless @cs==1;
+       ($changesfile) = @cs;
     }
-    if (!$nopush) {
-       runcmd qw(git push),$remotename,"HEAD:".lref(uploadbranch());
-       runcmd qw(dput),"../$dscfn";
+    my $tag = debiantag($dsc->{Version});
+    if (!check_for_git()) {
+       runcmd_ordryrun qw(ssh),$alioth_sshtestbodge->[0],
+       "set -e; cd $alioth_sshtestbodge->[1];".
+           " mkdir -p $package.git;".
+           " cd $package.git;".
+           " if ! test -d objects; then git init --bare; fi";
     }
+    runcmd_ordryrun @git, qw(push),$remotename,"HEAD:".lref(uploadbranch());
+    if ($sign) {
+       my @tag_cmd = (@git, qw(tag -s -m),
+                      "Release $dsc->{Version} for $suite [dgit]");
+       push @tag_cmd, qw(-u),$keyid if defined $keyid;
+       push @tag_cmd, $tag;
+       runcmd_ordryrun @tag_cmd;
+       my @debsign_cmd = @debsign;
+       push @debsign_cmd, "-k$keyid" if defined $keyid;
+       push @debsign_cmd, $changesfile;
+       runcmd_ordryrun @debsign_cmd;
+    }
+    runcmd_ordryrun @git, qw(push),$remotename,"refs/tags/$tag";
+    runcmd_ordryrun @dput, $changesfile;
 }
 
 sub cmd_clone {
@@ -368,42 +493,100 @@ sub cmd_clone {
 }
 
 sub branchsuite () {
-    $branch = `git-symbolic-ref HEAD`;
-    if ($branch =~ m#^refs/heads/dgit/([^/.]+)$#) {
+    my $branch = cmdoutput_errok @git, qw(symbolic-ref HEAD);
+    chomp $branch;
+    if ($branch =~ m#^refs/heads/$branchprefix/([^/.]+)$#o) {
        return $1;
     } else {
        return undef;
     }
 }
 
-sub cmd_fetch {
+sub fetchpullargs () {
     my $clogp = parsechangelog();
     $package = $clogp->{Source};
     if (@ARGV==0) {
        $suite = branchsuite();
        $suite ||= $clogp->{Distribution};
+       canonicalise_suite();
        print "fetching from suite $suite\n";
     } elsif (@ARGV==1) {
        ($suite) = @ARGV;
+       canonicalise_suite();
     } else {
        die;
     }
+}
+
+sub cmd_fetch {
+    fetchpullargs();
     fetch();
 }
 
+sub cmd_pull {
+    fetchpullargs();
+    pull();
+}
+
 sub cmd_push {
     my $clogp = parsechangelog();
     $package = $clogp->{Source};
     if (@ARGV==0) {
        $suite = $clogp->{Distribution};
+       canonicalise_suite();
     } else {
        die;
     }
     dopush();
 }
 
+sub cmd_build {
+    my $clogp = parsechangelog();
+    $suite = $clogp->{Distribution};
+    $package = $clogp->{Source};
+    canonicalise_suite();
+    runcmd_ordryrun
+       qw(git-buildpackage -us -uc --git-no-sign-tags),
+            "--git-debian-branch=".uploadbranch(),
+            @ARGV;
+}
+
 sub parseopts () {
-    die if @ARGV && $ARGV[0] =~ m/^\-/;
+    my $om;
+    while (@ARGV) {
+       last unless $ARGV[0] =~ m/^-/;
+       $_ = shift @ARGV;
+       last if m/^--?$/;
+       if (m/^--/) {
+           if (m/^--dry-run$/) {
+               $dryrun=1;
+           } elsif (m/^--no-sign$/) {
+               $sign=0;
+           } elsif (m/^--(\w+)=(.*)/s && ($om = $opts_opt_map{$1})) {
+               $om->[0] = $2;
+           } elsif (m/^--(\w+):(.*)/s && ($om = $opts_opt_map{$1})) {
+               push @$om, $2;
+           } else {
+               die "$_ ?";
+           }
+       } else {
+           while (m/^-./s) {
+               if (s/^-n/-/) {
+                   $dryrun=1;
+               } elsif (s/^-D/-/) {
+                   open DEBUG, ">&STDERR" or die $!;
+               } elsif (s/^-c(.*=.*)//s) {
+                   push @git, $1;
+               } elsif (s/^-C(.*)//s) {
+                   $changesfile = $1;
+               } elsif (s/^-k(.*)//s) {
+                   $keyid=$1;
+               } else {
+                   die "$_ ?";
+               }
+           }
+       }
+    }
 }
 
 parseopts();